package avatarSaver
{
	function NMH_type::send(%this)
	{
		%msg = %this.getValue();
		if(firstWord(%msg) $= ($Avatars::ControlChar@"load"))
		{
			%filt = "QWERTYUIOPASDFGHJKLZXCVBNM1234567890_";
			%msg = strReplace(restWords(%msg), " ", "_");
			for(%i=0;%i<strLen(%msg);%i++)
				if(striPos(%filt, getSubStr(%msg, %i, 1)) != -1)
					%name = %name@getSubStr(%msg, %i, 1);
			if(!isAvatar(%name))
				MessageBoxOK("Error!", "There is no avatar with that name!");
			else
			{
				loadAvatar(%name);
				forceSaveAvatar();
			}
			%msg = "";
		}
		else if(firstWord(%msg) $= ($Avatars::ControlChar@"save"))
		{
			%filt = "QWERTYUIOPASDFGHJKLZXCVBNM1234567890_";
			%msg = strReplace(restWords(%msg), " ", "_");
			for(%i=0;%i<strLen(%msg);%i++)
				if(striPos(%filt, getSubStr(%msg, %i, 1)) != -1)
					%name = %name@getSubStr(%msg, %i, 1);
			if(%name $= "")
			{
				MessageBoxOK("Error!", "You have to put in a name to save!");
				%this.setValue("");
				Parent::send(%this);
				return;
			}
			if(isAvatar(%name))
				MessageBoxYesNo("Are you sure?", "Do you want to overwrite the avatar \""@%name@"\"?", "saveAvatar(\""@%name@"\");");
			else
				saveAvatar(%name);
			%msg = "";
		}
		else if(firstWord(%msg) $= ($Avatars::ControlChar@"delete"))
		{
			%filt = "QWERTYUIOPASDFGHJKLZXCVBNM1234567890_";
			%msg = strReplace(restWords(%msg), " ", "_");
			for(%i=0;%i<strLen(%msg);%i++)
				if(striPos(%filt, getSubStr(%msg, %i, 1)) != -1)
					%name = %name@getSubStr(%msg, %i, 1);
			if(!isAvatar(%name))
				MessageBoxOK("Error!", "There is no avatar with that name!");
			else
				deleteAvatar(%name);
			%msg = "";
		}
		else if(firstWord(%msg) $= ($Avatars::ControlChar@"setChar"))
		{
			%char = restWords(%msg);
			if(strLen(%char) != 1)
			{
				if(%char $= "")
					MessageBoxOK("Error!", "You can't set the control character to be nothing!");
				else
					MessageBoxOK("Error!", "You can't set the control character to multiple characters!");
				%this.setValue("");
				Parent::send(%this);
				return;
			}
			%badChars = "qwertyuiopasdfghjklzxcvbnm 1234567890!@#$%^&*()\\\"";
			if(striPos(%badChars, %char) != -1)
			{
				%use = %char;
				if(%use $= "\"")%use = "\\\"";
				if(%use $= "\\")%use = "\\\\";
				MessageBoxYesNo("Are you sure?", "The character \""@%char@"\" is probably not one you want to use!\nDo you want to use it anyway?", "$Avatars::ControlChar = \""@%use@"\";export(\"$Avatars*\",\"config/client/avatars.cs\");");
			}
			$Avatars::ControlChar = %char;
			export("$Avatars::*", "config/client/avatars.cs");
			%msg = "";
		}
		%this.setValue(%msg);
		Parent::send(%this);
	}
	function MessageCallback(%a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l, %m, %n, %o, %p, %q, %r, %s, %t, %u, %v, %w, %x, %y, %z)
	{
		
		Parent::MessageCallback(%a, %b, %c, %d, %e, %f, %g, %h, %i, %j, %k, %l, %m, %n, %o, %p, %q, %r, %s, %t, %u, %v, %w, %x, %y, %z);
	}
};
activatePackage("avatarSaver");

function isAvatar(%name)
{
	if($Avatars::IsAvatar_[%name])
		return 1;
	return 0;
}

function forceSaveAvatar()
{
	%file = new fileObject(){};
	%file.openForRead("config/client/prefs.cs");
	while(!%file.isEOF())
		%line[-1+%lines++] = %file.readLine();
	%file.close();
	for(%i=0;%i<%lines;%i++)
		if(striPos(%line[%i], "$Pref::Avatar") == 0)
			%line[%i] = getWord(%line[%i], 0)@" = \""@eval("return "@getWord(%line[%i], 0)@";")@"\";";
	%file.openForWrite("config/client/prefs.cs");
	for(%i=0;%i<%lines;%i++)
		%file.writeLine(%line[%i]);
	%file.close();
	%file.delete();
}

function saveAvatar(%name)
{
	$Avatars::Accent_[%name] = $Pref::Avatar::Accent;
	$Avatars::AccentColor_[%name] = $Pref::Avatar::AccentColor;
	$Avatars::Authentic_[%name] = $Pref::Avatar::Authentic;
	$Avatars::Chest_[%name] = $Pref::Avatar::Chest;
	$Avatars::ChestColor_[%name] = $Pref::Avatar::ChestColor;
	$Avatars::DecalColor_[%name] = $Pref::Avatar::DecalColor;
	$Avatars::DecalName_[%name] = $Pref::Avatar::DecalName;
	$Avatars::FaceColor_[%name] = $Pref::Avatar::FaceColor;
	$Avatars::FaceName_[%name] = $Pref::Avatar::FaceName;
	$Avatars::Hat_[%name] = $Pref::Avatar::Hat;
	$Avatars::HatColor_[%name] = $Pref::Avatar::HatColor;
	$Avatars::HeadColor_[%name] = $Pref::Avatar::HeadColor;
	$Avatars::Hip_[%name] = $Pref::Avatar::Hip;
	$Avatars::HipColor_[%name] = $Pref::Avatar::HipColor;
	$Avatars::IsAvatar_[%name] = 1;
	$Avatars::LArm_[%name] = $Pref::Avatar::LArm;
	$Avatars::LArmColor_[%name] = $Pref::Avatar::LArmColor;
	$Avatars::LHand_[%name] = $Pref::Avatar::LHand;
	$Avatars::LHandColor_[%name] = $Pref::Avatar::LHandColor;
	$Avatars::LLeg_[%name] = $Pref::Avatar::LLeg;
	$Avatars::LLegColor_[%name] = $Pref::Avatar::LLegColor;
	$Avatars::Pack_[%name] = $Pref::Avatar::Pack;
	$Avatars::PackColor_[%name] = $Pref::Avatar::PackColor;
	$Avatars::RArm_[%name] = $Pref::Avatar::RArm;
	$Avatars::RArmColor_[%name] = $Pref::Avatar::RArmColor;
	$Avatars::RHand_[%name] = $Pref::Avatar::RHand;
	$Avatars::RHandColor_[%name] = $Pref::Avatar::RHandColor;
	$Avatars::RLeg_[%name] = $Pref::Avatar::RLeg;
	$Avatars::RLegColor_[%name] = $Pref::Avatar::RLegColor;
	$Avatars::SecondPack_[%name] = $Pref::Avatar::SecondPack;
	$Avatars::SecondPackColor_[%name] = $Pref::Avatar::SecondPackColor;
	$Avatars::Symmetry_[%name] = $Pref::Avatar::Symmetry;
	$Avatars::TorsoColor_[%name] = $Pref::Avatar::TorsoColor;
	for(%i=0;%i<$Avatars::Avatars;%i++)
		if($Avatars::AvatarName[%i] $= %name)
			%shift++;
		else
			$Avatars::AvatarName[%i - %shift] = $Avatars::AvatarName[%i];
	$Avatars::Avatars -= %shift;
	$Avatars::AvatarName[-1+$Avatars::Avatars++] = %name;
	export("$Avatars::*", "config/client/avatars.cs");
	AvatarSaver_tryUpdating();
}

function loadAvatar(%name)
{
	if(!isAvatar(%name))
		return;
	$Pref::Avatar::Accent = $Avatars::Accent_[%name];
	$Pref::Avatar::AccentColor = $Avatars::AccentColor_[%name];
	$Pref::Avatar::Authentic = $Avatars::Authentic_[%name];
	$Pref::Avatar::Chest = $Avatars::Chest_[%name];
	$Pref::Avatar::ChestColor = $Avatars::ChestColor_[%name];
	$Pref::Avatar::DecalColor = $Avatars::DecalColor_[%name];
	$Pref::Avatar::DecalName = $Avatars::DecalName_[%name];
	$Pref::Avatar::FaceColor = $Avatars::FaceColor_[%name];
	$Pref::Avatar::FaceName = $Avatars::FaceName_[%name];
	$Pref::Avatar::Hat = $Avatars::Hat_[%name];
	$Pref::Avatar::HatColor = $Avatars::HatColor_[%name];
	$Pref::Avatar::HeadColor = $Avatars::HeadColor_[%name];
	$Pref::Avatar::Hip = $Avatars::Hip_[%name];
	$Pref::Avatar::HipColor = $Avatars::HipColor_[%name];
	$Pref::Avatar::LArm = $Avatars::LArm_[%name];
	$Pref::Avatar::LArmColor = $Avatars::LArmColor_[%name];
	$Pref::Avatar::LHand = $Avatars::LHand_[%name];
	$Pref::Avatar::LHandColor = $Avatars::LHandColor_[%name];
	$Pref::Avatar::LLeg = $Avatars::LLeg_[%name];
	$Pref::Avatar::LLegColor = $Avatars::LLegColor_[%name];
	$Pref::Avatar::Pack = $Avatars::Pack_[%name];
	$Pref::Avatar::PackColor = $Avatars::PackColor_[%name];
	$Pref::Avatar::RArm = $Avatars::RArm_[%name];
	$Pref::Avatar::RArmColor = $Avatars::RArmColor_[%name];
	$Pref::Avatar::RHand = $Avatars::RHand_[%name];
	$Pref::Avatar::RHandColor = $Avatars::RHandColor_[%name];
	$Pref::Avatar::RLeg = $Avatars::RLeg_[%name];
	$Pref::Avatar::RLegColor = $Avatars::RLegColor_[%name];
	$Pref::Avatar::SecondPack = $Avatars::SecondPack_[%name];
	$Pref::Avatar::SecondPackColor = $Avatars::SecondPackColor_[%name];
	$Pref::Avatar::TorsoColor = $Avatars::TorsoColor_[%name];
	clientcmdUpdatePrefs();
}

function deleteAvatar(%name)
{
	if(!isAvatar(%name))
		return;
	for(%i=0;%i<$Avatars::Avatars;%i++)
		if($Avatars::AvatarName[%i] $= %name)
			%shift++;
		else
			$Avatars::AvatarName[%i - %shift] = $Avatars::AvatarName[%i];
	$Avatars::Avatars -= %shift;
	deleteVariables("$Avatars::*"@%name);
	export("$Avatars::*", "config/client/avatars.cs");
	AvatarSaver_tryUpdating();
}

if(isFile("config/client/avatars.cs"))
	exec("config/client/avatars.cs");

if(isFile("./gui.cs"))
{
	exec("./gui.cs");
	if(isFile("./editor.cs"))
		exec("./editor.cs");
	else
	{
		echo("\c2editor.cs is missing\c0 - operating without Editor");
		AvatarSaver_EditorButton.delete();
	}
}
else
	echo("\c2gui.cs is missing\c0 - operating without GUI interface");

if($Avatars::ControlChar $= "")
	$Avatars::ControlChar = "/";