function ASE_GenerateButton(%pos, %path, %command, %name)
{
	%button = new GuiBitmapCtrl()
		{
			position = %pos;
			extent = "64 64";
			
			bitmap = %path;
			
			new GuiBitmapButtonCtrl()
			{
				position = "0 0";
				extent = "64 64";
				
				bitmap = "base/client/ui/btnDecalA";
				text = "";
				
				command = %command;
			};
		};
	if(%name !$= "")
		%button.setName(%name);
	return %button;
}

function ASE_GenerateColorButton(%pos, %color, %command)
{
	return new GuiSwatchCtrl()
		{
			position = %pos;
			extent = "16 16";
			
			color = %color;
			
			new GuiBitmapButtonCtrl()
			{
				position = "0 0";
				extent = "16 16";
				
				bitmap = "Add-Ons/Client_AvatarSaver/SmallButton";
				text = "";
				
				command = %command;
			};
		};
}

new GuiControl(AvatarSaver_EditorGUI)
{
	visible = 0;
	
	position = "0 0";
	
	new GuiWindowCtrl(AvatarSaver_EditorUI)
	{
		position = "172 110";
		extent = "456 380";
		
		closeCommand = "Canvas.popDialog(AvatarSaver_EditorGUI);";
		command = "Canvas.popDialog(AvatarSaver_EditorGUI);";
		accelerator = "Escape";
		
		text = "Avatar Editor";
		
		resizeWidth = 0;
		resizeHeight = 0;
		
		canMinimize = 0;
		canMaximize = 0;
		
		new GuiSwatchCtrl()
		{
			position = "20 40";
			extent = "192 320";
			
			color = "255 255 255 255";
		};
		
		new GuiSwatchCtrl(ASE_FaceBG)
		{
			position = "20 40";
			extent = "64 64";
			
			color = "255 255 255 255";
		};
		
		new GuiSwatchCtrl(ASE_DecalBG)
		{
			position = "20 104";
			extent = "64 64";
			
			color = "255 255 255 255";
		};
	};
};

AvatarSaver_EditorUI.add(ASE_GenerateButton("20 40", "base/client/ui/avatarIcons/none", "AvatarSaver_EditorUI.wakeElementList(Face);", "ASE_FaceImage"));
AvatarSaver_EditorUI.add(ASE_GenerateButton("20 104", "base/client/ui/avatarIcons/none", "AvatarSaver_EditorUI.wakeElementList(Decal);", "ASE_DecalImage"));
AvatarSaver_EditorUI.add(ASE_GenerateButton("20 168", "base/client/ui/avatarIcons/chest/chest", "AvatarSaver_EditorUI.wakeElementList(Chest);", "ASE_ChestImage"));
AvatarSaver_EditorUI.add(ASE_GenerateButton("20 232", "Add-Ons/Client_AvatarSaver/Butterfly_Half", "$Pref::Player::Symmetry = !$Pref::Player::Symmetry;ASE_SymmetryImage.setBitmap($Pref::Player::Symmetry ? \"Add-Ons/Client_AvatarSaver/Butterfly_Full\" : \"Add-Ons/Client_AvatarSaver/Butterfly_Half\");", "ASE_SymmetryImage"));
AvatarSaver_EditorUI.add(ASE_GenerateButton("20 296", "base/client/ui/avatarIcons/hip/pants", "AvatarSaver_EditorUI.wakeElementList(Hip);", "ASE_HipImage"));
AvatarSaver_EditorUI.add(ASE_GenerateButton("84 40", "base/client/ui/avatarIcons/none", "AvatarSaver_EditorUI.wakeElementList(Hat);", "ASE_HatImage"));
AvatarSaver_EditorUI.add(ASE_GenerateButton("84 104", "base/client/ui/avatarIcons/none", "AvatarSaver_EditorUI.wakeElementList(Pack);", "ASE_PackImage"));
AvatarSaver_EditorUI.add(ASE_GenerateButton("84 168", "base/client/ui/avatarIcons/rarm/RArm", "AvatarSaver_EditorUI.wakeElementList(RArm);", "ASE_RArmImage"));
AvatarSaver_EditorUI.add(ASE_GenerateButton("84 232", "base/client/ui/avatarIcons/rhand/RHand", "AvatarSaver_EditorUI.wakeElementList(RHand);", "ASE_RHandImage"));
AvatarSaver_EditorUI.add(ASE_GenerateButton("84 296", "base/client/ui/avatarIcons/rleg/RShoe", "AvatarSaver_EditorUI.wakeElementList(RLeg);", "ASE_RLegImage"));
AvatarSaver_EditorUI.add(ASE_GenerateButton("148 40", "base/client/ui/avatarIcons/none", "AvatarSaver_EditorUI.wakeElementList(Accent);", "ASE_AccentImage"));
AvatarSaver_EditorUI.add(ASE_GenerateButton("148 104", "base/client/ui/avatarIcons/none", "AvatarSaver_EditorUI.wakeElementList(SecondPack);", "ASE_SecondPackImage"));
AvatarSaver_EditorUI.add(ASE_GenerateButton("148 168", "base/client/ui/avatarIcons/larm/LArm", "AvatarSaver_EditorUI.wakeElementList(LArm);", "ASE_LArmImage"));
AvatarSaver_EditorUI.add(ASE_GenerateButton("148 232", "base/client/ui/avatarIcons/lhand/LHand", "AvatarSaver_EditorUI.wakeElementList(LHand);", "ASE_LHandImage"));
AvatarSaver_EditorUI.add(ASE_GenerateButton("148 296", "base/client/ui/avatarIcons/lleg/LShoe", "AvatarSaver_EditorUI.wakeElementList(LLeg);", "ASE_LLegImage"));

function AvatarSaver_EditorUI::wakeElementList(%this, %element)
{
	if(!isObject(%this.elementList))
		%this.add(%this.elementList = new GuiSwatchCtrl()
			{
				position = "228 40";
				extent = "64 320";
				
				color = "255 255 255 255";
			});
	%list = %this.elementList;
	if(!isObject(%this.colorMenu))
	{
		%this.add(%this.colorMenu = new GuiSwatchCtrl()
		{
			position = "308 40";
			extent = "128 256";
			
			color = "0 0 0 0";
			
		//	new GuiRadioCtrl()
		//	{
		//		position = "0 2";
		//		extent = "128 16";
		//		
		//		command = "AvatarSaver_EditorUI.setActiveColorMenu(0);";
		//		text = "  Colorset";
		//	};
			
		//	new GuiRadioCtrl()
		//	{
		//		position = "0 18";
		//		extent = "128 16";
		//		
		//		command = "AvatarSaver_EditorUI.setActiveColorMenu(1);";
		//		text = "  RGB Editor";
		//	};
			
		//	new GuiRadioCtrl()
		//	{
		//		position = "0 34";
		//		extent = "128 16";
		//		
		//		command = "AvatarSaver_EditorUI.setActiveColorMenu(2);";
		//		text = "  HSL Editor";
		//	};
			
			new GuiSwatchCtrl(ASECM_Submenu0)
			{
				position = "0 64";
				extent = "128 192";
				
				color = "0 0 0 0";
			};
			
			new GuiSwatchCtrl(ASECM_Submenu1)
			{
				visible = 0;
				
				position = "0 64";
				extent = "128 192";
				
				color = "0 0 0 0";
			};
			
			new GuiSwatchCtrl(ASECM_Submenu2)
			{
				visible = 0;
				
				position = "0 64";
				extent = "128 192";
				
				color = "0 0 0 0";
			};
		});
		%this.colorMenu.getObject(0).setValue(1);
		for(%i=0;%i<64;%i++)
			if(isObject(%swatch = ("ColorSetSwatch"@%i)))
				ASECM_Submenu0.add(ASE_GenerateColorButton((%i%8)*16 SPC (%i-(%i%8))*2, %swatch.color, "AvatarSaver_EditorUI.setColor(\""@%swatch.color@"\");"));
	}
	%this.colorMenu.editing = %element;
	for(%i=0;%i<%list.getCount();%i++)
	{
		%obj = %list.getObject(%i);
		%obj.setVisible(0);
		if(%obj.element $= %list.showing)
			%obj.resize(0, getWord(%obj.position, 1) - (%list.pos * 64), 64, 64);
	}
	%shift = 0;
	%path = "base/client/ui/avatarIcons/";
	%path2 = "base/client/ui/btnDecalA";
	%list.setColor("1 1 1 1");
	if(!%list.has[%element])
	{
		switch$(%element)
		{
			case "Face":
				%dontColor = 1;
				%color = "1 1 1 1";
				%list.setColor($Pref::Avatar::HeadColor);
				%this.colorMenu.editing = "Head";
				%file = new fileObject();
				%file.openForRead("base/data/shapes/player/face.ifl");
				while(!%file.isEOF())
				{
					%path = %file.readLine();
					if(!isFile(%path))
						continue;
					%face = ASE_getThumbPath(%path);
					%list.add(ASE_GenerateButton(0 SPC (%num*64), %face, "AvatarSaver_EditorUI.setElementNumber(Face, \""@%path@"\");"));
					%num++;
				}
				%file.close();
				%file.delete();
			case "Decal":
				%dontColor = 1;
				%color = "1 1 1 1";
				%list.setColor($Pref::Avatar::TorsoColor);
				%this.colorMenu.editing = "Chest";
				%file = new fileObject();
				%file.openForRead("base/data/shapes/player/decal.ifl");
				while(!%file.isEOF())
				{
					%path = %file.readLine();
					if(!isFile(%path))
						continue;
					%decal = ASE_getThumbPath(%path);
					%list.add(ASE_GenerateButton(0 SPC (%num*64), %decal, "AvatarSaver_EditorUI.setElementNumber(Decal, \""@%path@"\");"));
					%num++;
				}
				%file.close();
				%file.delete();
			case "Chest":
				%color = $Pref::Avatar::TorsoColor;
				%list.add(ASE_GenerateButton("0 0", %path@"chest/chest", "AvatarSaver_EditorUI.setElementNumber(Chest, 0);"));
				%list.add(ASE_GenerateButton("0 64", %path@"chest/femchest", "AvatarSaver_EditorUI.setElementNumber(Chest, 1);"));
			case "Hip":
				%color = $Pref::Avatar::HipColor;
				%list.add(ASE_GenerateButton("0 0", %path@"hip/pants", "AvatarSaver_EditorUI.setElementNumber(Hip, 0);"));
				%list.add(ASE_GenerateButton("0 64", %path@"hip/skirtHip", "AvatarSaver_EditorUI.setElementNumber(Hip, 1);"));
			case "Hat":
				%color = $Pref::Avatar::HatColor;
				%list.add(ASE_GenerateButton("0 0", %path@"none", "AvatarSaver_EditorUI.setElementNumber(Hat, 0);"));
				%list.add(ASE_GenerateButton("0 64", %path@"hat/helmet", "AvatarSaver_EditorUI.setElementNumber(Hat, 1);"));
				%list.add(ASE_GenerateButton("0 128", %path@"hat/pointyhelmet", "AvatarSaver_EditorUI.setElementNumber(Hat, 2);"));
				%list.add(ASE_GenerateButton("0 192", %path@"hat/flareHelmet", "AvatarSaver_EditorUI.setElementNumber(Hat, 3);"));
				%list.add(ASE_GenerateButton("0 256", %path@"hat/scouthat", "AvatarSaver_EditorUI.setElementNumber(Hat, 4);"));
				%list.add(ASE_GenerateButton("0 320", %path@"hat/bicorn", "AvatarSaver_EditorUI.setElementNumber(Hat, 5);"));
				%list.add(ASE_GenerateButton("0 384", %path@"hat/copHat", "AvatarSaver_EditorUI.setElementNumber(Hat, 6);"));
				%list.add(ASE_GenerateButton("0 448", %path@"hat/knitHat", "AvatarSaver_EditorUI.setElementNumber(Hat, 7);"));
			case "Pack":
				%color = $Pref::Avatar::PackColor;
				%list.add(ASE_GenerateButton("0 0", %path@"none", "AvatarSaver_EditorUI.setElementNumber(Pack, 0);"));
				%list.add(ASE_GenerateButton("0 64", %path@"/pack/armor", "AvatarSaver_EditorUI.setElementNumber(Pack, 1);"));
				%list.add(ASE_GenerateButton("0 128", %path@"/pack/bucket", "AvatarSaver_EditorUI.setElementNumber(Pack, 2);"));
				%list.add(ASE_GenerateButton("0 192", %path@"/pack/cape", "AvatarSaver_EditorUI.setElementNumber(Pack, 3);"));
				%list.add(ASE_GenerateButton("0 256", %path@"/pack/pack", "AvatarSaver_EditorUI.setElementNumber(Pack, 4);"));
				%list.add(ASE_GenerateButton("0 320", %path@"/pack/quiver", "AvatarSaver_EditorUI.setElementNumber(Pack, 5);"));
				%list.add(ASE_GenerateButton("0 384", %path@"/pack/tank", "AvatarSaver_EditorUI.setElementNumber(Pack, 6);"));
			case "RArm":
				%color = $Pref::Avatar::RArmColor;
				%list.add(ASE_GenerateButton("0 0", %path@"rarm/RArm", "AvatarSaver_EditorUI.setElementNumber(RArm, 0);"));
				%list.add(ASE_GenerateButton("0 64", %path@"rarm/RArmSlim", "AvatarSaver_EditorUI.setElementNumber(RArm, 1);"));
			case "RHand":
				%color = $Pref::Avatar::RHandColor;
				%list.add(ASE_GenerateButton("0 0", %path@"rhand/RHand", "AvatarSaver_EditorUI.setElementNumber(RHand, 0);"));
				%list.add(ASE_GenerateButton("0 64", %path@"rhand/RHook", "AvatarSaver_EditorUI.setElementNumber(RHand, 1);"));
			case "RLeg":
				%color = $Pref::Avatar::RLegColor;
				%list.add(ASE_GenerateButton("0 0", %path@"rleg/RShoe", "AvatarSaver_EditorUI.setElementNumber(RLeg, 0);"));
				%list.add(ASE_GenerateButton("0 64", %path@"rleg/RPeg", "AvatarSaver_EditorUI.setElementNumber(RLeg, 1);"));
			case "Accent":
				%color = $Pref::Avatar::AccentColor;
				%list.add(ASE_GenerateButton("0 0", %path@"none", "AvatarSaver_EditorUI.setElementNumber(Accent, 0);"));
				if($Pref::Avatar::Hat == 1)
					%list.add(ASE_GenerateButton("0 64", %path@"/accent/visor", "AvatarSaver_EditorUI.setElementNumber(Accent, 1);"));
				else if($Pref::Avatar::Hat == 4 || $Pref::Avatar::Hat == 6 || $Pref::Avatar::Hat == 7)
				{
					%list.add(ASE_GenerateButton("0 64", %path@"/accent/plume", "AvatarSaver_EditorUI.setElementNumber(Accent, 1);"));
					%list.add(ASE_GenerateButton("0 128", %path@"/accent/triplume", "AvatarSaver_EditorUI.setElementNumber(Accent, 2);"));
					%list.add(ASE_GenerateButton("0 192", %path@"/accent/septplume", "AvatarSaver_EditorUI.setElementNumber(Accent, 3);"));
				}
			case "SecondPack":
				%color = $Pref::Avatar::SecondPackColor;
				%list.add(ASE_GenerateButton("0 0", %path@"none", "AvatarSaver_EditorUI.setElementNumber(SecondPack, 0);"));
				%list.add(ASE_GenerateButton("0 64", %path@"/secondPack/epaulets", "AvatarSaver_EditorUI.setElementNumber(SecondPack, 1);"));
				%list.add(ASE_GenerateButton("0 128", %path@"/secondPack/epauletsRankA", "AvatarSaver_EditorUI.setElementNumber(SecondPack, 2);"));
				%list.add(ASE_GenerateButton("0 192", %path@"/secondPack/epauletsRankB", "AvatarSaver_EditorUI.setElementNumber(SecondPack, 3);"));
				%list.add(ASE_GenerateButton("0 256", %path@"/secondPack/epauletsRankC", "AvatarSaver_EditorUI.setElementNumber(SecondPack, 4);"));
				%list.add(ASE_GenerateButton("0 320", %path@"/secondPack/epauletsRankD", "AvatarSaver_EditorUI.setElementNumber(SecondPack, 5);"));
				%list.add(ASE_GenerateButton("0 384", %path@"/secondPack/ShoulderPads", "AvatarSaver_EditorUI.setElementNumber(SecondPack, 6);"));
			case "LArm":
				%color = $Pref::Avatar::LArmColor;
				%list.add(ASE_GenerateButton("0 0", %path@"larm/LArm", "AvatarSaver_EditorUI.setElementNumber(LArm, 0);"));
				%list.add(ASE_GenerateButton("0 64", %path@"larm/LArmSlim", "AvatarSaver_EditorUI.setElementNumber(LArm, 1);"));
			case "LHand":
				%color = $Pref::Avatar::LHandColor;
				%list.add(ASE_GenerateButton("0 0", %path@"lhand/LHand", "AvatarSaver_EditorUI.setElementNumber(LHand, 0);"));
				%list.add(ASE_GenerateButton("0 64", %path@"lhand/LHook", "AvatarSaver_EditorUI.setElementNumber(LHand, 1);"));
			case "LLeg":
				%color = $Pref::Avatar::LLegColor;
				%list.add(ASE_GenerateButton("0 0", %path@"lleg/LShoe", "AvatarSaver_EditorUI.setElementNumber(LLeg, 0);"));
				%list.add(ASE_GenerateButton("0 64", %path@"lleg/LPeg", "AvatarSaver_EditorUI.setElementNumber(LLeg, 1);"));
		}
		%shift = 1;
	}
	else
		switch$(%element)
		{
			case "Face":
				%color = $Pref::Avatar::HeadColor;
				%list.setColor($Pref::Avatar::HeadColor);
				%this.colorMenu.editing = "Head";
			case "Decal":
				%color = $Pref::Avatar::TorsoColor;
				%list.setColor($Pref::Avatar::TorsoColor);
				%this.colorMenu.editing = "Chest";
			case "Chest":
				%color = $Pref::Avatar::TorsoColor;
			default:
				%color = $Pref::Avatar["::"@%element@"Color"];
		}
	%list.active = 0;
	for(%i=0;%i<%list.getCount();%i++)
	{
		%obj = %list.getObject(%i);
		if(%obj.element $= "")
			%obj.element = %element;
		if(%obj.element $= %element)
		{
			%obj.setVisible(1);
			%obj.setColor(%color);
			%list.active++;
		}
		if(%obj.element $= "Arrow")
		{
			%obj.delete();
			%i--;
		}
	}
	%list.has[%element] = 1;
	%list.showing = %element;
	if(%list.active > 5)
	{
		%list.resize(228, 40, 64, 320);
		if(%shift)
		{
			for(%i=0;%i<%list.getCount();%i++)
				if((%obj = %list.getObject(%i)).element $= %element)
					%obj.resize(0, getWord(%obj.position, 1) + 32, 64, 64);
		}
		%list.maxPos = %list.active - 4;
	//	if(!isObject(%list.upArrow))
			%list.add(%list.upArrow = new GuiBitmapCtrl()
				{
					position = "0 0";
					extent = "64 32";
					
					bitmap = "Add-Ons/Client_AvatarSaver/UpArrow";
					element = "Arrow";
					isArrow = 1;
					
					new GuiBitmapButtonCtrl()
					{
						position = "0 0";
						extent = "64 32";
						
						bitmap = "Add-Ons/Client_AvatarSaver/HalfButton";
						text = "";
						
						command = "ASE_ScrollUp();";
					};
				});
	//	if(!isObject(%list.downArrow))
			%list.add(%list.downArrow = new GuiBitmapCtrl()
				{
					position = "0 288";
					extent = "64 32";
					
					bitmap = "Add-Ons/Client_AvatarSaver/DownArrow";
					element = "Arrow";
					isArrow = 1;
					
					new GuiBitmapButtonCtrl()
					{
						position = "0 0";
						extent = "64 32";
						
						bitmap = "Add-Ons/Client_AvatarSaver/HalfButton";
						text = "";
						
						command = "ASE_ScrollDown();";
					};
				});
		%list.pos = 0;
	}
	else
		%list.resize(228, 40, 64, %list.active * 64);
	%list.dontColor = %dontColor + 0;
}

function ASE_getThumbPath(%path)
{
	%ind = 0;while((%temp = strPos(%path, "/", %ind)) != -1)%ind = %temp + 1;
	%thumb = getSubStr(%path, 0, %ind)@"thumbs/"@getSubStr(%path, %ind, strLen(%path) - (%ind + 4));
	return %thumb;
}

function ASE_ScrollUp()
{
	if(!isObject(%list = AvatarSaver_EditorUI.elementList))
		return;
	if(%list.pos > 0)
	{
		for(%i=0;%i<%list.getCount();%i++)
			if(!(%obj = %list.getObject(%i)).isArrow)
				%obj.resize(0, getWord(%obj.position, 1) + 64, 64, 64);
		%list.pos--;
	}
}

function ASE_ScrollDown()
{
	if(!isObject(%list = AvatarSaver_EditorUI.elementList))
		return;
	if(%list.pos < %list.maxPos)
	{
		for(%i=0;%i<%list.getCount();%i++)
			if(!(%obj = %list.getObject(%i)).isArrow)
				%obj.resize(0, getWord(%obj.position, 1) - 64, 64, 64);
		%list.pos++;
	}
}

function AvatarSaver_EditorUI::setColor(%this, %col)
{
	if(!isObject(%menu = %this.colorMenu))
		return;
	for(%i=0;%i<4;%i++)
		%color = %color SPC (getWord(%col, %i) / 255);
	if(isObject(%list = %this.elementList) && !%list.dontColor)
	{
		for(%i=0;%i<%list.getCount();%i++)
			if(!(%obj = %list.getObject(%i)).isArrow)
				%obj.setColor(%color);
	}
	if(%menu.editing $= "Head")
		%list.setColor(trim(%color));
	%this.setElementColor(%menu.editing, trim(%color));
}

function AvatarSaver_EditorUI::setActiveColorMenu(%this, %num)
{
	if(!isObject(%menu = %this.colorMenu))
		return;
	for(%i=3;%i<6;%i++)
		%menu.getObject(%i).setVisible(0);
	%menu.getObject(%num+3).setVisible(1);
}

function AvatarSaver_EditorUI::setElementNumber(%this, %element, %num)
{
	%path = "base/client/ui/avatarIcons/";
	switch$(%element)
	{
		case "Face":
			$Pref::Avatar::FaceName = %num;
			ASE_FaceImage.setBitmap(ASE_getThumbPath(%num));
		case "Decal":
			$Pref::Avatar::DecalName = %num;
			ASE_DecalImage.setBitmap(ASE_getThumbPath(%num));
		case "Chest":
			$Pref::Avatar::Chest = %num;
			ASE_ChestImage.setBitmap($Pref::Avatar::Chest ? %path@"chest/femchest" : %path@"chest/chest");
		case "Hip":
			$Pref::Avatar::Hip = %num;
			ASE_HipImage.setBitmap($Pref::Avatar::Hip ? %path@"hip/skirtHip" : %path@"hip/pants");
			if($Pref::Avatar::Hip)
			{
				if(!isObject(AvatarSaver_EditorUI.legBlocker))
					AvatarSaver_EditorUI.add(AvatarSaver_EditorUI.legBlocker = new GuiSwatchCtrl()
						{
							position = "84 296";
							extent = "128 64";
							
							color = "255 255 255 128";
						});
			}
			else if(isObject(AvatarSaver_EditorUI.legBlocker))
				AvatarSaver_EditorUI.legBlocker.delete();
		case "Hat":
			$Pref::Avatar::Hat = %num;
			if($Pref::Avatar::Hat == 1)
				ASE_HatImage.setBitmap(%path@"hat/helmet");
			else if($Pref::Avatar::Hat == 2)
				ASE_HatImage.setBitmap(%path@"hat/pointyhelmet");
			else if($Pref::Avatar::Hat == 3)
				ASE_HatImage.setBitmap(%path@"hat/flareHelmet");
			else if($Pref::Avatar::Hat == 4)
				ASE_HatImage.setBitmap(%path@"hat/scouthat");
			else if($Pref::Avatar::Hat == 5)
				ASE_HatImage.setBitmap(%path@"hat/bicorn");
			else if($Pref::Avatar::Hat == 6)
				ASE_HatImage.setBitmap(%path@"hat/copHat");
			else if($Pref::Avatar::Hat == 7)
				ASE_HatImage.setBitmap(%path@"hat/knitHat");
			else
				ASE_HatImage.setBitmap(%path@"none");
			AvatarSaver_EditorUI.setElementNumber(Accent, $Pref::Avatar::Accent);
		case "Pack":
			$Pref::Avatar::Pack = %num;
			if($Pref::Avatar::Pack == 1)
				ASE_PackImage.setBitmap(%path@"pack/armor");
			else if($Pref::Avatar::Pack == 2)
				ASE_PackImage.setBitmap(%path@"pack/bucket");
			else if($Pref::Avatar::Pack == 3)
				ASE_PackImage.setBitmap(%path@"pack/cape");
			else if($Pref::Avatar::Pack == 4)
				ASE_PackImage.setBitmap(%path@"pack/pack");
			else if($Pref::Avatar::Pack == 5)
				ASE_PackImage.setBitmap(%path@"pack/quiver");
			else if($Pref::Avatar::Pack == 6)
				ASE_PackImage.setBitmap(%path@"pack/tank");
			else
				ASE_PackImage.setBitmap(%path@"none");
		case "RArm":
			$Pref::Avatar::RArm = %num;
			ASE_RArmImage.setBitmap($Pref::Avatar::RArm ? %path@"rarm/RArmSlim" : %path@"rarm/RArm");
			if($Pref::Player::Symmetry)
			{
				$Pref::Avatar::LArm = %num;
				ASE_LArmImage.setBitmap($Pref::Avatar::LArm ? %path@"larm/LArmSlim" : %path@"larm/LArm");
			}
		case "RHand":
			$Pref::Avatar::RHand = %num;
			ASE_RHandImage.setBitmap($Pref::Avatar::RHand ? %path@"rhand/RHook" : %path@"rhand/RHand");
			if($Pref::Player::Symmetry)
			{
				$Pref::Avatar::LHand = %num;
				ASE_LHandImage.setBitmap($Pref::Avatar::LHand ? %path@"lhand/LHook" : %path@"lhand/LHand");
			}
		case "RLeg":
			$Pref::Avatar::RLeg = %num;
			ASE_RLegImage.setBitmap($Pref::Avatar::RLeg ? %path@"rleg/RPeg" : %path@"rleg/RShoe");
			if($Pref::Player::Symmetry)
			{
				$Pref::Avatar::LLeg = %num;
				ASE_LLegImage.setBitmap($Pref::Avatar::LLeg ? %path@"lleg/LPeg" : %path@"lleg/LShoe");
			}
		case "Accent":
			$Pref::Avatar::Accent = %num;
			if($Pref::Avatar::Hat == 1)
				if($Pref::Avatar::Accent == 1)
					ASE_AccentImage.setBitmap(%path@"accent/visor");
				else
					ASE_AccentImage.setBitmap(%path@"none");
			else if($Pref::Avatar::Hat == 4 || $Pref::Avatar::Hat == 6 || $Pref::Avatar::Hat == 7)
				if($Pref::Avatar::Accent == 1)
					ASE_AccentImage.setBitmap(%path@"accent/plume");
				else if($Pref::Avatar::Accent == 2)
					ASE_AccentImage.setBitmap(%path@"accent/triplume");
				else if($Pref::Avatar::Accent == 3)
					ASE_AccentImage.setBitmap(%path@"accent/septplume");
				else
					ASE_AccentImage.setBitmap(%path@"none");
			else
				ASE_AccentImage.setBitmap(%path@"none");
		case "SecondPack":
			$Pref::Avatar::SecondPack = %num;
			if($Pref::Avatar::SecondPack == 1)
				ASE_SecondPackImage.setBitmap(%path@"secondPack/epaulets");
			else if($Pref::Avatar::SecondPack == 2)
				ASE_SecondPackImage.setBitmap(%path@"secondPack/epauletsRankA");
			else if($Pref::Avatar::SecondPack == 3)
				ASE_SecondPackImage.setBitmap(%path@"secondPack/epauletsRankB");
			else if($Pref::Avatar::SecondPack == 4)
				ASE_SecondPackImage.setBitmap(%path@"secondPack/epauletsRankC");
			else if($Pref::Avatar::SecondPack == 5)
				ASE_SecondPackImage.setBitmap(%path@"secondPack/epauletsRankD");
			else if($Pref::Avatar::SecondPack == 6)
				ASE_SecondPackImage.setBitmap(%path@"secondPack/ShoulderPads");
			else
				ASE_SecondPackImage.setBitmap(%path@"none");
		case "LArm":
			$Pref::Avatar::LArm = %num;
			ASE_LArmImage.setBitmap($Pref::Avatar::LArm ? %path@"larm/LArmSlim" : %path@"larm/LArm");
			if($Pref::Player::Symmetry)
			{
				$Pref::Avatar::RArm = %num;
				ASE_RArmImage.setBitmap($Pref::Avatar::RArm ? %path@"rarm/RArmSlim" : %path@"rarm/RArm");
			}
		case "LHand":
			$Pref::Avatar::LHand = %num;
			ASE_LHandImage.setBitmap($Pref::Avatar::LHand ? %path@"lhand/LHook" : %path@"lhand/LHand");
			if($Pref::Player::Symmetry)
			{
				$Pref::Avatar::RHand = %num;
				ASE_RHandImage.setBitmap($Pref::Avatar::RHand ? %path@"rhand/RHook" : %path@"rhand/RHand");
			}
		case "LLeg":
			$Pref::Avatar::LLeg = %num;
			ASE_LLegImage.setBitmap($Pref::Avatar::LLeg ? %path@"lleg/LPeg" : %path@"lleg/LShoe");
			if($Pref::Player::Symmetry)
			{
				$Pref::Avatar::RLeg = %num;
				ASE_RLegImage.setBitmap($Pref::Avatar::RLeg ? %path@"rleg/RPeg" : %path@"rleg/RShoe");
			}
	}
}

function AvatarSaver_EditorUI::setElementColor(%this, %element, %color)
{
	switch$(%element)
	{
		case "Chest":
			$Pref::Avatar::HeadColor = %color;
			ASE_ChestImage.setColor(%color);
		case "Chest":
			$Pref::Avatar::TorsoColor = %color;
			ASE_ChestImage.setColor(%color);
		case "Hip":
			$Pref::Avatar::HipColor = %color;
			ASE_HipImage.setColor(%color);
		case "Hat":
			$Pref::Avatar::HatColor = %color;
			ASE_HatImage.setColor(%color);
		case "Pack":
			$Pref::Avatar::PackColor = %color;
			ASE_PackImage.setColor(%color);
		case "RArm":
			$Pref::Avatar::RArmColor = %color;
			ASE_RArmImage.setColor(%color);
			if($Pref::Player::Symmetry)
			{
				$Pref::Avatar::LArmColor = %color;
				ASE_LArmImage.setColor(%color);
			}
		case "RHand":
			$Pref::Avatar::RHandColor = %color;
			ASE_RHandImage.setColor(%color);
			if($Pref::Player::Symmetry)
			{
				$Pref::Avatar::LHandColor = %color;
				ASE_LHandImage.setColor(%color);
			}
		case "RLeg":
			$Pref::Avatar::RLegColor = %color;
			ASE_RLegImage.setColor(%color);
			if($Pref::Player::Symmetry)
			{
				$Pref::Avatar::LLegColor = %color;
				ASE_LLegImage.setColor(%color);
			}
		case "Accent":
			$Pref::Avatar::AccentColor = %color;
			ASE_AccentImage.setColor(%color);
		case "SecondPack":
			$Pref::Avatar::SecondPackColor = %color;
			ASE_SecondPackImage.setColor(%color);
		case "LArm":
			$Pref::Avatar::LArmColor = %color;
			ASE_LArmImage.setColor(%color);
			if($Pref::Player::Symmetry)
			{
				$Pref::Avatar::RArmColor = %color;
				ASE_RArmImage.setColor(%color);
			}
		case "LHand":
			$Pref::Avatar::LHandColor = %color;
			ASE_LHandImage.setColor(%color);
			if($Pref::Player::Symmetry)
			{
				$Pref::Avatar::RHandColor = %color;
				ASE_RHandImage.setColor(%color);
			}
		case "LLeg":
			$Pref::Avatar::LLegColor = %color;
			ASE_LLegImage.setColor(%color);
			if($Pref::Player::Symmetry)
			{
				$Pref::Avatar::RLegColor = %color;
				ASE_RLegImage.setColor(%color);
			}
	}
}

function AvatarSaver_EditorGUI::onWake(%this)
{
	%this.setVisible(1);
	if((%pos = $Avatars::EditorPos) !$= "")
		AvatarSaver_EditorUI.resize(getWord(%pos, 0), getWord(%pos, 1), 500, 380);
	%path = "base/client/ui/avatarIcons/";
	if(isFile($Pref::Avatar::FaceName))
		ASE_FaceImage.setBitmap(ASE_getThumbPath($Pref::Avatar::FaceName));
	ASE_FaceBG.setColor($Pref::Avatar::HeadColor);
	if(isFile($Pref::Avatar::DecalName))
		ASE_DecalImage.setBitmap(ASE_getThumbPath($Pref::Avatar::DecalName));
	ASE_DecalBG.setColor($Pref::Avatar::TorsoColor);
	if($Pref::Avatar::Chest == 1)
		ASE_ChestImage.setBitmap(%path@"chest/femchest");
	else
		ASE_ChestImage.setBitmap(%path@"chest/chest");
	ASE_ChestImage.setColor($Pref::Avatar::TorsoColor);
	ASE_SymmetryImage.setBitmap($Pref::Player::Symmetry ? "Add-Ons/Client_AvatarSaver/Butterfly_Full" : "Add-Ons/Client_AvatarSaver/Butterfly_Half");
	if($Pref::Avatar::Hip == 1)
	{
		ASE_HipImage.setBitmap(%path@"hip/skirtHip");
		if(!isObject(AvatarSaver_EditorUI.legBlocker))
			AvatarSaver_EditorUI.add(AvatarSaver_EditorUI.legBlocker = new GuiSwatchCtrl()
				{
					position = "84 296";
					extent = "128 64";
					
					color = "255 255 255 128";
				});
	}
	else
	{
		ASE_HipImage.setBitmap(%path@"hip/pants");
		if(isObject(AvatarSaver_EditorUI.legBlocker))
			AvatarSaver_EditorUI.legBlocker.delete();
	}
	ASE_HipImage.setColor($Pref::Avatar::HipColor);
	if($Pref::Avatar::Hat == 1)
		ASE_HatImage.setBitmap(%path@"hat/helmet");
	else if($Pref::Avatar::Hat == 2)
		ASE_HatImage.setBitmap(%path@"hat/pointyhelmet");
	else if($Pref::Avatar::Hat == 3)
		ASE_HatImage.setBitmap(%path@"hat/flareHelmet");
	else if($Pref::Avatar::Hat == 4)
		ASE_HatImage.setBitmap(%path@"hat/scouthat");
	else if($Pref::Avatar::Hat == 5)
		ASE_HatImage.setBitmap(%path@"hat/bicorn");
	else if($Pref::Avatar::Hat == 6)
		ASE_HatImage.setBitmap(%path@"hat/copHat");
	else if($Pref::Avatar::Hat == 7)
		ASE_HatImage.setBitmap(%path@"hat/knitHat");
	else
		ASE_HatImage.setBitmap(%path@"none");
	ASE_HatImage.setColor($Pref::Avatar::HatColor);
	if($Pref::Avatar::Pack == 1)
		ASE_PackImage.setBitmap(%path@"pack/armor");
	else if($Pref::Avatar::Pack == 2)
		ASE_PackImage.setBitmap(%path@"pack/bucket");
	else if($Pref::Avatar::Pack == 3)
		ASE_PackImage.setBitmap(%path@"pack/cape");
	else if($Pref::Avatar::Pack == 4)
		ASE_PackImage.setBitmap(%path@"pack/pack");
	else if($Pref::Avatar::Pack == 5)
		ASE_PackImage.setBitmap(%path@"pack/quiver");
	else if($Pref::Avatar::Pack == 6)
		ASE_PackImage.setBitmap(%path@"pack/tank");
	else
		ASE_PackImage.setBitmap(%path@"none");
	ASE_PackImage.setColor($Pref::Avatar::PackColor);
	if($Pref::Avatar::RArm)
		ASE_RArmImage.setBitmap(%path@"rarm/RArmSlim");
	else
		ASE_RArmImage.setBitmap(%path@"rarm/RArm");
	ASE_RArmImage.setColor($Pref::Avatar::RArmColor);
	if($Pref::Avatar::RHand)
		ASE_RHandImage.setBitmap(%path@"rhand/RHook");
	else
		ASE_RHandImage.setBitmap(%path@"rhand/RHand");
	ASE_RHandImage.setColor($Pref::Avatar::RHandColor);
	if($Pref::Avatar::RLeg)
		ASE_RLegImage.setBitmap(%path@"rleg/RPeg");
	else
		ASE_RLegImage.setBitmap(%path@"rleg/RShoe");
	ASE_RLegImage.setColor($Pref::Avatar::RLegColor);
	if($Pref::Avatar::Hat == 1)
		if($Pref::Avatar::Accent)
			ASE_AccentImage.setBitmap(%path@"accent/visor");
		else
			ASE_AccentImage.setBitmap(%path@"none");
	else if($Pref::Avatar::Hat == 4 || $Pref::Avatar::Hat == 6 || $Pref::Avatar::Hat == 7)
		if($Pref::Avatar::Accent == 1)
			ASE_AccentImage.setBitmap(%path@"accent/plume");
		else if($Pref::Avatar::Accent == 2)
			ASE_AccentImage.setBitmap(%path@"accent/triplume");
		else if($Pref::Avatar::Accent == 3)
			ASE_AccentImage.setBitmap(%path@"accent/septplume");
		else
			ASE_AccentImage.setBitmap(%path@"none");
	else
		ASE_AccentImage.setBitmap(%path@"none");
	ASE_AccentImage.setColor($Pref::Avatar::AccentColor);
	if($Pref::Avatar::SecondPack == 1)
		ASE_SecondPackImage.setBitmap(%path@"secondPack/epaulets");
	else if($Pref::Avatar::SecondPack == 2)
		ASE_SecondPackImage.setBitmap(%path@"secondPack/epauletsRankA");
	else if($Pref::Avatar::SecondPack == 3)
		ASE_SecondPackImage.setBitmap(%path@"secondPack/epauletsRankB");
	else if($Pref::Avatar::SecondPack == 4)
		ASE_SecondPackImage.setBitmap(%path@"secondPack/epauletsRankC");
	else if($Pref::Avatar::SecondPack == 5)
		ASE_SecondPackImage.setBitmap(%path@"secondPack/epauletsRankD");
	else if($Pref::Avatar::SecondPack == 6)
		ASE_SecondPackImage.setBitmap(%path@"secondPack/ShoulderPads");
	else
		ASE_SecondPackImage.setBitmap(%path@"none");
	ASE_SecondPackImage.setColor($Pref::Avatar::SecondPackColor);
	if($Pref::Avatar::LArm)
		ASE_LArmImage.setBitmap(%path@"larm/LArmSlim");
	else
		ASE_LArmImage.setBitmap(%path@"larm/LArm");
	ASE_LArmImage.setColor($Pref::Avatar::RArmColor);
	if($Pref::Avatar::LHand)
		ASE_LHandImage.setBitmap(%path@"lhand/LHook");
	else
		ASE_LHandImage.setBitmap(%path@"lhand/LHand");
	ASE_LHandImage.setColor($Pref::Avatar::LHandColor);
	if($Pref::Avatar::LLeg)
		ASE_LLegImage.setBitmap(%path@"lleg/LPeg");
	else
		ASE_LLegImage.setBitmap(%path@"lleg/LShoe");
	ASE_LLegImage.setColor($Pref::Avatar::LLegColor);
}

function AvatarSaver_EditorGUI::onSleep(%this)
{
	clientcmdUpdatePrefs();
	%this.setVisible(0);
	$Avatars::EditorPos = AvatarSaver_EditorUI.position;
	export("$Avatars::*", "config/client/avatars.cs");
}

function RGBtoHSL(%r, %g, %b)
{
	%max = mMax(%r, mMax(%g, %b));
	%min = mMin(%r, mMin(%g, %b));
	if(%max > 1 || %min < 0)
		return -1;
	%lum = (%max + %min) / 2;
	if(%max == %min)
	{
		%sat = 0;
		%hue = 0;
	}
	else
	{
		if(%lum < 0.5)
			%sat = (%max - %min) / (%max + %min);
		else
			%sat = (%max - %min) / (2 - %max - %min);
		if(%r == %max)
			%hue = (%g - %b) / (%max - %min);
		else if(%g == %max)
			%hue = 2 + (%b - %r) / (%max - %min);
		else
			%hue = 4 + (%r - %g) / (%max - %min);
	}
	%hue *= 60;
	if(%hue < 0)
		%hue += 360;
	return %hue SPC %sat * 100 SPC %lum * 100;
}

function HSLtoRGB(%hue, %sat, %lum)
{
	%hue /= 360;%sat /= 100;%lum /= 100;
	if(%sat == 0)
	{
		%r = %lum;
		%g = %lum;
		%b = %lum;
	}
	else
	{
		if(%lum <= 0.5)
			%m2 = %lum*(%sat+1);
		else
			%m2 = (%lum+%sat)-(%lum*%sat);
		%m1 = (%lum*2)-%m2;
		%r = HuetoRGB(%m1, %m2, %hue+(1/3));
		%g = HuetoRGB(%m1, %m2, %hue);
		%b = HuetoRGB(%m1, %m2, %hue-(1/3));
	}
	return %r * 255 SPC %b * 255 SPC %g * 255;
}

function HuetoRGB(%m1, %m2, %hue)
{
	if(%h<0)%h++;if(%h>0)%h--;
	if(%h*6<1)return %m1+(%m2-%m1)*%hue*6;
	if(%h*2<1)return %m2;
	if(%h*3<2)return %m1+(%m2-%m1)*((2/3)-%hue)*6;
	return %m1;
}

function mMax(%a, %b)
{
	if(%a > %b)
		return %a;
	return %b;
}

function mMin(%a, %b)
{
	if(%a < %b)
		return %a;
	return %b;
}