new GuiControl(AvatarSaverGUI)
{
	visible = 0;
	
	position = "0 0";
	
	new GuiWindowCtrl(AvatarSaverUI)
	{
		position = "240 120";
		extent = "320 360";
		
		closeCommand = "toggleAvatarSaverGUI(1);";
		command = "toggleAvatarSaverGUI(1);";
		accelerator = "Escape";
		
		text = "Avatar Saver";
		
		resizeWidth = 0;
		resizeHeight = 0;
		
		canMinimize = 0;
		canMaximize = 0;
		
		new GuiSwatchCtrl()
		{
			position = "20 40";
			extent = "200 270";
			
			color = "255 255 255 128";
		};
		
		new GuiScrollCtrl()
		{
			position = "20 40";
			extent = "200 270";
			
			profile = "ColorScrollProfile";
			
			hScrollBar = "alwaysOff";
			vScrollBar = "alwaysOn";
			willFirstRespond = 1;
			
			new GuiTextListCtrl(AvatarSaver_AvatarList)
			{
				position = "0 0";
				fitParentWidth = 1;
				columns = "0 270";
				
				clipColumnText = 0;
				profile = "GuiTextListProfile";
				command = "AvatarSaver_processListSelection();";
			};
		};
		
		new GuiTextEditCtrl(AvatarSaver_InputField)
		{
			position = "20 320";
			extent = "200 20";
			
			maxLength = 30;
			historySize = 0;
			sinkAllKeyEvents = 0;
			
			command = "if($Pref::AvatarSaver::SearchForAvatars)AvatarSaver_tryUpdating();";
		};
		
		new GuiBitmapButtonCtrl(AvatarSaver_SaveButton)
		{
			position = "240 40";
			extent = "60 24";
			
			text = "Save";
			mColor = "102 102 255 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "AvatarSaver_trySaving();";
		};
		
		new GuiBitmapButtonCtrl(AvatarSaver_LoadButton)
		{
			position = "240 70";
			extent = "60 24";
			
			text = "Load";
			mColor = "102 255 102 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "AvatarSaver_tryLoading();";
		};
		
		new GuiBitmapButtonCtrl(AvatarSaver_DeleteButton)
		{
			position = "240 100";
			extent = "60 24";
			
			text = "Delete";
			mColor = "255 102 102 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "AvatarSaver_tryDeleting();";
		};
		
		new GuiBitmapButtonCtrl(AvatarSaver_SortButton)
		{
			position = "240 130";
			extent = "60 24";
			
			text = "Sort";
			mColor = "255 0 0 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "AvatarSaver_toggleSorting();";
		};
		
		new GuiBitmapButtonCtrl(AvatarSaver_OptionsButton)
		{
			position = "230 258";
			extent = "80 24";
			
			text = "Options";
			mColor = "204 204 204 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "Canvas.pushDialog(AvatarSaver_OptionsGUI);";
		};
		
		new GuiBitmapButtonCtrl(AvatarSaver_AvatarButton)
		{
			position = "230 288";
			extent = "80 24";
			
			text = "Avatar";
			mColor = "102 255 255 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "Canvas.pushDialog(AvatarGUI);";
		};
		
		new GuiBitmapButtonCtrl(AvatarSaver_EditorButton)
		{
			position = "230 318";
			extent = "80 24";
			
			text = "Editor";
			mColor = "255 255 102 255";
			
			bitmap = "base/client/ui/button1";
			profile = "BlockButtonProfile";
			command = "Canvas.pushDialog(AvatarSaver_EditorGUI);";
		};
	};
};

new GuiControl(AvatarSaver_OptionsGUI)
{
	visible = 0;
	
	position = "0 0";
	
	new GuiWindowCtrl(AvatarSaver_OptionsUI)
	{
		position = "250 200";
		extent = "300 200";
		
		closeCommand = "Canvas.popDialog(AvatarSaver_OptionsGUI);";
		command = "Canvas.popDialog(AvatarSaver_OptionsGUI);";
		accelerator = "Escape";
		
		text = "Avatar Saver Options";
		
		resizeWidth = 0;
		resizeHeight = 0;
		
		canMinimize = 0;
		canMaximize = 0;
		
		new GuiCheckboxCtrl()
		{
			position = "15 35";
			extent = "120 20";
			
			text = "Close on Loading";
			variable = "$Pref::AvatarSaver::CloseOnLoad";
		};
		new GuiCheckboxCtrl()
		{
			position = "15 55";
			extent = "120 20";
			
			text = "Close on Saving";
			variable = "$Pref::AvatarSaver::CloseOnSave";
		};
		new GuiCheckboxCtrl()
		{
			position = "15 85";
			extent = "120 20";
			
			text = "Loading Popup";
			variable = "$Pref::AvatarSaver::NotifyOnLoad";
		};
		new GuiCheckboxCtrl()
		{
			position = "15 105";
			extent = "120 20";
			
			text = "Saving Popup";
			variable = "$Pref::AvatarSaver::NotifyOnSave";
		};
		new GuiCheckboxCtrl()
		{
			position = "15 125";
			extent = "120 20";
			
			text = "Search for Avatars";
			variable = "$Pref::AvatarSaver::SearchForAvatars";
		};
	};
};

function AvatarSaver_toggleSorting()
{
	$Avatars::SortList = !$Avatars::SortList;
	AvatarSaver_SortButton.setColor($Avatars::SortList ? "0 255 0 255" : "255 0 0 255");
	export("$Avatars::*", "config/client/avatars.cs");
	AvatarSaver_tryUpdating();
}

function AvatarSaver_tryDeleting()
{
	%this = AvatarSaver_InputField;
	%text = strReplace(%this.getValue(), " ", "_");
	%this.setValue("");
	%filt = "QWERTYUIOPASDFGHJKLZXCVBNM1234567890_";
	for(%i=0;%i<strLen(%text);%i++)
		if(striPos(%filt, getSubStr(%text, %i, 1)) != -1)
			%name = %name@getSubStr(%text, %i, 1);
	if(%name $= "")
	{
		MessageBoxOK("Error!", "You have to put in a name to delete!");
		return;
	}
	if(isAvatar(%name))
		MessageBoxYesNo("Are you sure?", "Do you want to delete the avatar \""@%name@"\"?\nThis is permanent and cannot be undone.", "deleteAvatar(\""@%name@"\");");
	if($Pref::AvatarSaver::SearchForAvatars)
		AvatarSaver_tryUpdating();
}

function AvatarSaver_tryLoading()
{
	%this = AvatarSaver_InputField;
	%text = strReplace(%this.getValue(), " ", "_");
	%this.setValue("");
	%filt = "QWERTYUIOPASDFGHJKLZXCVBNM1234567890_";
	for(%i=0;%i<strLen(%text);%i++)
		if(striPos(%filt, getSubStr(%text, %i, 1)) != -1)
			%name = %name@getSubStr(%text, %i, 1);
	if(%name $= "")
	{
		MessageBoxOK("Error!", "You have to put in a name to load!");
		return;
	}
	if(!isAvatar(%name))
		MessageBoxOK("Error!", "There is no avatar with that name!");
	else
	{
		loadAvatar(%name);
		forceSaveAvatar();
		if($Pref::AvatarSaver::NotifyOnLoad)
			MessageBoxOK("Success!", "Loaded avatar "@%name@"!");
		if($Pref::AvatarSaver::CloseOnLoad)
			toggleAvatarSaverGUI(1);
		if($Pref::AvatarSaver::SearchForAvatars)
			AvatarSaver_tryUpdating();
	}
}

function AvatarSaver_trySaving()
{
	%this = AvatarSaver_InputField;
	%text = strReplace(%this.getValue(), " ", "_");
	%this.setValue("");
	%filt = "QWERTYUIOPASDFGHJKLZXCVBNM1234567890_";
	for(%i=0;%i<strLen(%text);%i++)
		if(striPos(%filt, getSubStr(%text, %i, 1)) != -1)
			%name = %name@getSubStr(%text, %i, 1);
	if(%name $= "")
	{
		MessageBoxOK("Error!", "You have to put in a name to save!");
		return;
	}
	if(isAvatar(%name))
		MessageBoxYesNo("Are you sure?", "Do you want to overwrite the avatar \""@%name@"\"?", "saveAvatar(\""@%name@"\");if($Pref::AvatarSaver::NotifyOnSave)MessageBoxOK(\"Success!\", \"Saved avatar "@%name@"!\");if($Pref::AvatarSaver::CloseOnSave)toggleAvatarSaverGUI(1);");
	else
	{
		saveAvatar(%name);
		if($Pref::AvatarSaver::NotifyOnSave)
			MessageBoxOK("Success!", "Saved avatar "@%name@"!");
		if($Pref::AvatarSaver::CloseOnSave)
			toggleAvatarSaverGUI(1);
		if($Pref::AvatarSaver::SearchForAvatars)
			AvatarSaver_tryUpdating();
	}
	AvatarSaver_tryUpdating();
}

function AvatarSaver_tryUpdating()
{
	%this = AvatarSaverGUI;
	if(!%this.visible)
		return;
	%list = AvatarSaver_AvatarList;
	while(%list.rowCount() > 0)
		%list.removeRow(0);
	if($Pref::AvatarSaver::SearchForAvatars)
		%query = AvatarSaver_InputField.getValue();
	for(%i=0;%i<$Avatars::Avatars;%i++)
		if(striPos((%name = $Avatars::AvatarName[%i]), strReplace(%query, " ", "_")) != -1)
			%list.addRow(%list.rowCount(), strReplace(%name, "_", " "));
	if($Avatars::SortList)
		AvatarSaver_AvatarList.sort(0, 1);
}

function AvatarSaver_processListSelection()
{
	%this = AvatarSaver_AvatarList;
	%id = %this.getSelectedID();
	if(%id == -1)
		return;
	%textbox = AvatarSaver_InputField;
	%textbox.setValue(%this.getRowTextByID(%id));
}

function AvatarSaverGUI::onWake(%this)
{
	if($Avatars::SortList $= "")
		$Avatars::SortList = 0;
	else
		AvatarSaver_SortButton.setColor($Avatars::SortList ? "0 255 0 255" : "255 0 0 255");
	AvatarSaver_InputField.setValue("");
	%list = AvatarSaver_AvatarList;
	for(%i=0;%i<$Avatars::Avatars;%i++)
		%list.addRow(%list.rowCount(), strReplace($Avatars::AvatarName[%i], "_", " "));
	if($Avatars::SortList)
		%list.sort(0, 1);
	%this.setVisible(1);
	if((%pos = $Avatars::MainPos) !$= "")
		AvatarSaverUI.resize(getWord(%pos, 0), getWord(%pos, 1), 320, 360);
}

function AvatarSaverGUI::onSleep(%this)
{
	%this.setVisible(0);
	%list = AvatarSaver_AvatarList;
	while(%list.rowCount() > 0)
		%list.removeRow(0);
	$Avatars::MainPos = AvatarSaverUI.position;
	export("$Avatars::*", "config/client/avatars.cs");
}

function AvatarSaver_OptionsGUI::onWake(%this)
{
	%this.setVisible(1);
	if((%pos = $Avatars::OptionsPos) !$= "")
		AvatarSaver_OptionsUI.resize(getWord(%pos, 0), getWord(%pos, 1), 300, 200);
}

function AvatarSaver_OptionsGUI::onSleep(%this)
{
	%this.setVisible(0);
	$Avatars::OptionsPos = AvatarSaver_OptionsUI.position;
	export("$Avatars::*", "config/client/avatars.cs");
}

function toggleAvatarSaverGUI(%tog)
{
	if(!%tog)
		return;
	%this = AvatarSaverGUI;
	if(%this.visible)
		Canvas.popDialog(%this);
	else
		Canvas.pushDialog(%this);
}

if(!$AvatarSaverGUI::boundCommand)
{
	$AvatarSaverGUI::boundCommand = 1;
	$remapDivision[$remapCount] = "Avatar Saver";
	$remapName[$remapCount] = "Toggle GUI";
	$remapCmd[$remapCount] = "toggleAvatarSaverGUI";
	$remapCount++;
}

package avatarSaverGUI
{
	function AvatarGUI::onWake(%this)
	{
		Parent::onWake(%this);
		if(AvatarSaverGUI.visible)
		{
			$AvatarSaverGUI::resumeOnClose = 1;
			Canvas.popDialog(AvatarSaverGUI);
		}
		if(AvatarSaver_OptionsGUI.visible)
		{
			$AvatarSaver_OptionsGUI::resumeOnClose = 1;
			Canvas.popDialog(AvatarSaver_OptionsGUI);
		}
		if(AvatarSaver_EditorGUI.visible)
		{
			$AvatarSaver_EditorGUI::resumeOnClose = 1;
			Canvas.popDialog(AvatarSaver_EditorGUI);
		}
	}
	
	function AvatarGUI::onSleep(%this)
	{
		Parent::onSleep(%this);
		if($AvatarSaverGUI::resumeOnClose)
		{
			Canvas.pushDialog(AvatarSaverGUI);
			$AvatarSaverGUI::resumeOnClose = 0;
		}
		if($AvatarSaver_OptionsGUI::resumeOnClose)
		{
			Canvas.pushDialog(AvatarSaver_OptionsGUI);
			$AvatarSaver_OptionsGUI::resumeOnClose = 0;
		}
		if($AvatarSaver_EditorGUI::resumeOnClose)
		{
			Canvas.pushDialog(AvatarSaver_EditorGUI);
			ASE_SymmetryImage.setBitmap($Pref::Player::Symmetry ? "Add-Ons/Client_AvatarSaver/Butterfly_Full" : "Add-Ons/Client_AvatarSaver/Butterfly_Half");
			$AvatarSaver_EditorGUI::resumeOnClose = 0;
		}
	}
	
	function ColorSetGui::onSleep(%this)
	{
		if(isObject(%menu = ASECM_Submenu0))
		{
			while(%menu.getCount() != 0)
				%menu.getObject(0).delete();
			for(%i=0;%i<64;%i++)
				if(isObject(%swatch = ("ColorSetSwatch"@%i)))
					ASECM_Submenu0.add(ASE_GenerateColorButton((%i%8)*16 SPC (%i-(%i%8))*2, %swatch.color, "AvatarSaver_EditorUI.setColor("@%swatch.color@");"));
		}
	}
};
activatePackage("avatarSaverGUI");

if(!$Pref::AvatarSaver::SetPrefs)
{
	$Pref::AvatarSaver::SetPrefs = 1;
	$Pref::AvatarSaver::CloseOnLoad = 0;
	$Pref::AvatarSaver::CloseOnSave = 0;
	$Pref::AvatarSaver::NotifyOnLoad = 1;
	$Pref::AvatarSaver::NotifyOnSave = 1;
}